
/* Chrysalide - Outil d'analyse de fichiers binaires
 * apihash.h - prototypes pour la détermination d'API par empreinte de fonction
 *
 * Copyright (C) 2023 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _PLUGINS_APIHASHING_APIHASH_H
#define _PLUGINS_APIHASHING_APIHASH_H


#include <glib-object.h>


#include <analysis/scan/patterns/modifier.h>



#define G_TYPE_API_HASH_MODIFIER            g_api_hash_modifier_get_type()
#define G_API_HASH_MODIFIER(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), G_TYPE_API_HASH_MODIFIER, GApiHashModifier))
#define G_IS_API_HASH_MODIFIER(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), G_TYPE_API_HASH_MODIFIER))
#define G_API_HASH_MODIFIER_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_API_HASH_MODIFIER, GApiHashModifierClass))
#define G_IS_API_HASH_MODIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_API_HASH_MODIFIER))
#define G_API_HASH_MODIFIER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_API_HASH_MODIFIER, GApiHashModifierClass))


/* Transormation en empreinte d'API (instance) */
typedef GScanTokenModifier GApiHashModifier;

/* Transormation en empreinte d'API (classe) */
typedef GScanTokenModifierClass GApiHashModifierClass;


/* Indique le type défini pour une transormation en empreinte d'API. */
GType g_api_hash_modifier_get_type(void);



#endif  /* _PLUGINS_APIHASHING_APIHASH_H */
