
/* Chrysalide - Outil d'analyse de fichiers binaires
 * hyperscan-int.h - prototypes internes pour la méthode de recherche basée sur la bibliothèque Hyperscan d'Intel
 *
 * Copyright (C) 2024 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_SCAN_PATTERNS_BACKENDS_HYPERSCAN_INT_H
#define _ANALYSIS_SCAN_PATTERNS_BACKENDS_HYPERSCAN_INT_H


#include "hyperscan.h"


#include "../backend-int.h"



#define EXPR_COVERAGE_START   0
#define EXPR_COVERAGE_COUNT   1
#define EXPR_COVERAGE_END     1


/* Méthode de recherche basée sur une bibliothèque d'Intel : Hyperscan (instance) */
struct _GHyperscanBackend
{
    GEngineBackend parent;                  /* A laisser en premier        */

    const uint8_t **atoms;                  /* Motif remarquable           */
    size_t *lengths;                        /* Nombre d'octets considérés  */
    uint32_t *coverages;                    /* Départ et quantité de suivis*/
    size_t allocated;                       /* Nombre d'éléments alloués   */
    size_t used;                            /* Nombre d'éléments utiles    */

    unsigned int *lit_ids;                  /* Identifiants internes       */

    hs_database_t *database;                /* Compilation d'éléments      */
    hs_scratch_t *scratch;                  /* Espace de travail           */

};

/* Méthode de recherche basée sur une bibliothèque d'Intel : Hyperscan (classe) */
struct _GHyperscanBackendClass
{
    GEngineBackendClass parent;             /* A laisser en premier        */

};



#endif  /* _ANALYSIS_SCAN_PATTERNS_BACKENDS_HYPERSCAN_INT_H */
